
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stay_foliosDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stay_folios = await db.stay_folios.create(
            {
                id: data.id || undefined,
        
        folio_number: data.folio_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        balance_due: data.balance_due
        ||
        null
            ,
            
        total_charges: data.total_charges
        ||
        null
            ,
            
        total_payments: data.total_payments
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stay_folios.setHotel( data.hotel || null, {
            transaction,
        });
        
        await stay_folios.setReservation( data.reservation || null, {
            transaction,
        });
        
        await stay_folios.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return stay_folios;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stay_foliosData = data.map((item, index) => ({
                id: item.id || undefined,
                
                folio_number: item.folio_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                balance_due: item.balance_due
            ||
            null
            ,
            
                total_charges: item.total_charges
            ||
            null
            ,
            
                total_payments: item.total_payments
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stay_folios = await db.stay_folios.bulkCreate(stay_foliosData, { transaction });

        // For each item created, replace relation files
        

        return stay_folios;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const stay_folios = await db.stay_folios.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.folio_number !== undefined) updatePayload.folio_number = data.folio_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.balance_due !== undefined) updatePayload.balance_due = data.balance_due;
        
        
        if (data.total_charges !== undefined) updatePayload.total_charges = data.total_charges;
        
        
        if (data.total_payments !== undefined) updatePayload.total_payments = data.total_payments;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await stay_folios.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await stay_folios.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        
        if (data.reservation !== undefined) {
            await stay_folios.setReservation(
              
              data.reservation,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await stay_folios.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return stay_folios;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stay_folios = await db.stay_folios.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stay_folios) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stay_folios) {
                await record.destroy({transaction});
            }
        });


        return stay_folios;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stay_folios = await db.stay_folios.findByPk(id, options);

        await stay_folios.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stay_folios.destroy({
            transaction
        });

        return stay_folios;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stay_folios = await db.stay_folios.findOne(
            { where },
            { transaction },
        );

        if (!stay_folios) {
            return stay_folios;
        }

        const output = stay_folios.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.folio_items_stay_folio = await stay_folios.getFolio_items_stay_folio({
            transaction
        });
        
        
        output.payments_stay_folio = await stay_folios.getPayments_stay_folio({
            transaction
        });
        
        
        
        output.invoices_stay_folio = await stay_folios.getInvoices_stay_folio({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.hotel = await stay_folios.getHotel({
            transaction
        });
        
        
        output.reservation = await stay_folios.getReservation({
            transaction
        });
        
        
        output.organizations = await stay_folios.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.reservations,
        as: 'reservation',
        
        where: filter.reservation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reservation.split('|').map(term => Utils.uuid(term)) } },
            {
              reservation_number: {
                [Op.or]: filter.reservation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.folio_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stay_folios',
                        'folio_number',
                        filter.folio_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stay_folios',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.balance_dueRange) {
                const [start, end] = filter.balance_dueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_chargesRange) {
                const [start, end] = filter.total_chargesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_charges: {
                    ...where.total_charges,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_charges: {
                    ...where.total_charges,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_paymentsRange) {
                const [start, end] = filter.total_paymentsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_payments: {
                    ...where.total_payments,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_payments: {
                    ...where.total_payments,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stay_folios.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stay_folios',
                        'folio_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stay_folios.findAll({
            attributes: [ 'id', 'folio_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['folio_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.folio_number,
        }));
    }

    
};

